100 set_windows:test
110 :
120 DEFine PROCedure test
130 LOCal object_hit,hit%,lp%,none_yet$
140 LOCal text$(2,20),file_name$(50),option_chosen
150 LOCal config_options$(200,80),my_option$(81),ylines
160 LOCal fname_edline,infotext,sep_obj,menu_object,fs,add_info
170 LOCal number_of_elements%,watermark$,box_left,loose_item
180 :
190   REMark note how I use a Local string variables here, since the
200   REMark window will be gone when we leave this procedure!
210 :
220   REMark first initialise some variables
230 :
240   watermark$="% configuration file for ProWesS"
250   option_chosen=0
260   mem=0:hit%=0:object_hit=0
270   text$(1)="Prowess Config"&CHR$(0)     : REMark the title, and button text
280   text$(2)="Config file: "&CHR$(0)      :
290   none_yet$="<no file yet>"&CHR$(0)
300   file_name$=none_yet$                  : REMark name of the config file
310 :
320   REMark now create all of the objects needed at first
330 :
340   outl=PWcreate(0,PW('TYPE_OUTLINE'),PW('OUTLINE_SLEEP'),PW('OUTLINE_SLEEP_TEXT'),text$(1),PW('OUTLINE_QUIT'),PW('OUTLINE_QUIT_KEYPRESS'),27,PW('OUTLINE_TITLE_TEXT'),text$(1))
350 :
360   REMark use chr$(27) = ESC as keypress for the quit item
370 :
380   ylines=PWquery(outl,PW('DEFAULT_FONTSIZE'))
390   ylines=INT(ylines/65536)+6
400   ylines=INT((ysize%-80)/ylines)
410 :
420   infotext=PWcreate(outl,PW('TYPE_LABEL'),PW('LABEL_TEXT'),text$(2))
430 :
440   fname_edline=PWcreate(outl,PW('TYPE_EDLINE'),PW('EDLINE_MAXLENGTH'),41,PW('EDLINE_SET'),file_name$,PW('EDLINE_ACTION_AFTER'),HIT_ROUTINE,PW('EDLINE_KEYPRESS'),CODE('c'),PW('EDLINE_ACTION_DO'),DO_ROUTINE)
450 :
460   sep_obj=PWcreate(outl,PW('TYPE_SEPARATOR'))
470 :
480   menu_object=PWcreate(outl,PW('TYPE_MENU'),PW('MENU_ITEMWIDTH_PIX'),420,PW('MENU_VISIBLE_LINES'),ylines,PW('MENU_ACTION_SELECT'),DO_ROUTINE,PW('MENU_UNIQUE'))
490 :
500   fs= PWcreate(outl,PW('TYPE_FILESELECT'))
510 :
520   box_left=PWquery(outl,PW('OUTLINE_BOX_LEFT') )
530   loose_item=PWcreate(box_left,PW('TYPE_LOOSE_ITEM'),PW('LOOSE_TEXT_COPY'),"Save",PW('LOOSE_ACTION_HIT'),HIT_ROUTINE,PW('LOOSE_KEYPRESS'),CODE('s'))
540 :
550 REMark now the main loop
560 :
570   REPeat lp%
580     mem=PWactivate(outl,mem,object_hit,add_info,hit%)
590     IF NOT mem:EXIT lp%                 : REMark program is finished
600     SELect ON object_hit                : REMark no let's see what was hit
610       =fname_edline                     : REMark object hit= filename editor
620          SELect ON hit%                 : REMark HIT or DO?
630            =0
640              file_name$=get_from_edline$ (fname_edline,0)
650            =1
660              file_name$=select_file$
670              PWchange fname_edline,PW('EDLINE_SET'),file_name$
680          END SELect
690          load_the_file
700       =menu_object                      : REMark object hit was menu
710          get_choice                     : REMark get the string to configure
720          IF LEN(my_option$)>1
730            popup_window                 : REMark popup win with this string
740            set_option                   : REMark do the configuration
750          END IF
760          PWchange menu_object,PW('MENU_STATUS_CURRENT'),PW('STATUS_AVAILABLE')
770       =loose_item
780          save_the_file
790     END SELect
800   END REPeat lp%
810 :
820   PWremove outl     : REMark this also removes all the objects owned by this one
830 END DEFine test
840 :
850 REMark -------------------------------------------------------------------
860 REMark the following 2 functions get the filename, called for a hit or
870 REMark a do the the edline object
880 REMark -------------------------------------------------------------------
890 :
900 DEFine FuNction get_from_edline$ (object,strip_chr0%)
910 REMark this gets the text from the edline object and returns it
920 REMark if strip_chr0% is set, the CHR$(0) at the end of the string is
930 REMark stripped off
940 REMark rem the max length of the string is 80 characters
950 LOCal my_string$(81)
960   PWchange object,PW('EDLINE_GET'),80,my_string$ : REMark get string from edline
970   IF strip_chr0%
980     MKLEN my_string$                    : REMark set new length w/o chr$(0)
990   ELSE
1000     MKLEN0 my_string$                   : REMark set new length keep chr$(0)
1010   END IF
1020   RETurn my_string$                     : REMark and return the string
1030 END DEFine get_from_edline$
1040 :
1050 DEFine FuNction select_file$
1060 REMark this activates the fileselect object and
1070 REMark gets the string (composed of dirname + filename) from
1080 REMark the fileselect object
1090 LOCal f_name$
1100   PWchange fs,PW('FILESELECT_ACTIVATE') : REMark activate fileselect window
1110   f_name$=PWquery(fs,PW('FILESELECT_DIRECTORY'))
1120   f_name$=f_name$&PWquery(fs,PW('FILESELECT_FILENAME'))
1130   RETurn f_name$&CHR$(0)
1140 END DEFine select_file$
1150 :
1160 REMark -------------------------------------------------------------------
1170 REMark the following procedure displays a small 'please wait' window, opens
1180 REMark the file, reads in the options and changes the menu object
1190 REMark -------------------------------------------------------------------
1200 :
1210 DEFine PROCedure load_the_file
1220 REMark this displays the 'please wait' window
1230 REMark and loads the file
1240 LOCal lp%,a%,a$,f$,wait$,loop%,dummy,dummy%
1250 LOCal lf_info
1260 LOCal lf_out,lf_mem
1270 :
1280   wait$="Reading file - please wait"&CHR$(0)
1290   lf_mem=0:dummy=0:dummy%=0:number_of_elements%=0
1300 :
1310   REMark now create the objects
1320 :
1330   lf_outl=PWcreate(0,PW('TYPE_OUTLINE'),PW('SYSTEM_ACTION_INIT'),INIT_ROUTINE)
1340 :
1350   lf_info=PWcreate(lf_outl,PW('TYPE_INFOSTRING'),PW('INFOSTRING_TEXT'),wait$)
1360 :
1370   REMark now the main 'loop'
1380   REPeat loop%
1390     lf_mem=PWactivate(lf_outl,lf_mem,dummy,dummy,dummy%)
1400     IF NOT lf_mem:EXIT loop%            : REMark this will quit after the PWbreak
1410     f$=file_name$(1 TO LEN(file_name$)-1) : REMark strip off chr$(0)
1420     a%=FOP_IN(f$)                       : REMark open file
1430     IF a%<0
1440        err_window a%,''                 : REMark oops!
1450        PWbreak lf_outl
1460        NEXT loop%
1470     END IF
1480     INPUT#a%,a$
1490     IF a$<>watermark$
1500       CLOSE#a%                          : REMark make a small check
1510       err_window 0,"This is not a Prowess config file!"
1520       PWbreak lf_outl                   : REMark oops...
1530       NEXT loop%
1540     END IF
1550     REPeat lp%
1560       IF EOF(#a%):EXIT lp%
1570       INPUT#a%;a$
1580       config_options$(number_of_elements%)=a$&CHR$(0)
1590       number_of_elements%=number_of_elements%+ 1
1600     END REPeat lp%
1610     CLOSE#a%
1620     PWbreak lf_outl
1630     PWchange menu_object,PW('MENU_CLEAR')    : REMark get rid of old items
1640     PWchange menu_object,PW('MENU_ADD_ARRAY'),number_of_elements%,DIMN(config_options$,2)+2,config_options$
1650   END REPeat loop%
1660   PWremove lf_outl
1670 END DEFine load_the_file
1680 :
1690 REMark -------------------------------------------------------------------
1700 REMark the following procedure gets the choice hit in the menu
1710 REMark -------------------------------------------------------------------
1720 :
1730 DEFine PROCedure get_choice
1740 REMark get the choice hit in the menu
1750 LOCal address, a%
1760   option_chosen=0
1770   address=PWquery(menu_object,PW('MENU_SELECTED_FIRST')) : REMark what item was selected?
1780   IF NOT address:RETurn                    : REMark oops!
1790   my_option$=MKSTRING$(address)&CHR$(0)    : REMark get the string
1800   option_chosen=arrsrch(config_options$,my_option$)
1810 END DEFine get_choice
1820 :
1830 DEFine FuNction arrsrch(array$,string$)
1840 LOCal lp,endd
1850   endd=DIMN(array$,1)
1860   FOR lp=0 TO endd:IF array$(lp)==string$:RETurn lp
1870   RETurn -1
1880 END DEFine arrsrch
1890 :
1900 REMark -------------------------------------------------------------------
1910 REMark the following procedure pops up the window where the string can be edited
1920 REMark -------------------------------------------------------------------
1930 :
1940 DEFine PROCedure popup_window
1950 REMark this pops up the window in which the string can be edited
1960 LOCal dummy,dummy%,lp%,string$
1970 LOCal cfg_edline
1980 LOCal pop_outl,pop_mem
1990 :
2000   string$='Please edit this string...'&CHR$(0)
2010   pop_mem= 0
2020 :
2030   pop_outl=PWcreate(0,PW('TYPE_OUTLINE'),PW('OUTLINE_TITLE_TEXT'),string$ )
2040 :
2050   cfg_edline=PWcreate(pop_outl,PW('TYPE_DIRECT_EDLINE'),PW('EDLINE_MAXLENGTH'),80,PW('EDLINE_SET'),my_option$,PW('EDLINE_ACTION_AFTER'),HIT_ROUTINE)
2060 :
2070   REMark now the main 'loop'
2080 :
2090   REPeat lp%
2100     pop_mem=PWactivate(pop_outl,pop_mem,dummy,dummy,dummy%)
2110     IF pop_mem=0:EXIT lp%
2120     my_option$=get_from_edline$(cfg_edline,0)
2130     PWbreak pop_outl          : REMark show we don't want the window anymore
2140   END REPeat lp%
2150   PWremove pop_outl           : REMark get rid of this window
2160 END DEFine popup_window
2170 :
2180 REMark -------------------------------------------------------------------
2190 REMark the following procedure set the configuration choice
2200 REMark -------------------------------------------------------------------
2210 :
2220 DEFine PROCedure set_option
2230 REMark this does the actual configuration with PWconfig
2240 LOCal string$,p$
2250   p$="prowess"
2260   string$=my_option$         : REMark this is necessary, pwconfig changes the string!
2270   PWconfig p$,string$
2280   config_options$(option_chosen)=my_option$
2290 END DEFine set_option
2300 :
2310 REMark -------------------------------------------------------------------
2320 REMark the following procedure displays a small 'please wait' window
2330 REMark and prints the options to the file
2340 REMark -------------------------------------------------------------------
2350 :
2360 DEFine PROCedure save_the_file
2370 REMark this displays the 'please wait' window
2380 REMark and saves the file
2390 LOCal lp%,a$,f$,wait$,loop%,dummy,dummy%
2400 LOCal sf_info,outchan%
2410 LOCal sf_out,sf_mem
2420 :
2430   wait$="Saving file - please wait"&CHR$(0)
2440   sf_mem=0:dummy=0:dummy%=0:counter%=0
2450 :
2460   REMark now create the objects
2470 :
2480   sf_outl=PWcreate(0,PW('TYPE_OUTLINE'),PW('SYSTEM_ACTION_INIT'),DO_ROUTINE)
2490 :
2500   sf_info=PWcreate(sf_outl,PW('TYPE_INFOSTRING'),PW('INFOSTRING_TEXT'),wait$)
2510 :
2520   REMark now the main 'loop'
2530   REPeat loop%
2540     sf_mem=PWactivate(sf_outl,sf_mem,dummy,dummy,dummy%)
2550     IF NOT sf_mem:EXIT loop%            : REMark this will quit after the PWbreak
2560     f$=file_name$(1 TO LEN(file_name$)-1) : REMark strip off chr$(0)
2570     outchan%=FOP_OVER(f$)
2580     IF outchan%<0
2590       err_window outchan%,""
2600       PWbreak sf_outl
2610       NEXT loop%
2620     END IF
2630     PRINT#outchan%,watermark$
2640     FOR lp%=0 TO number_of_elements%
2650       f$=config_options$(lp%)
2660       dummy%=LEN(f$)
2670       IF dummy%=1
2680          PRINT#outchan%
2690       ELSE
2700          PRINT#outchan%,f$(1 TO dummy%-1)
2710       END IF
2720     END FOR lp%
2730     CLOSE#outchan%
2740     PWbreak sf_outl
2750   END REPeat loop%
2760   PWremove sf_outl
2770   PWchange loose_item,PW('LOOSE_STATUS'),PW('STATUS_AVAILABLE')
2780 END DEFine save_the_file
2790 :
2800 REMark -------------------------------------------------------------------
2810 REMark the following procedure pops up an error window
2820 REMark -------------------------------------------------------------------
2830 :
2840 DEFine PROCedure err_window (error%,error_string$)
2850 REMark this makes the error string if that isn't set,
2860 REMark and sets it in the infostring item
2870 LOCal dummy,dummy%,lp%,string$(1,40)
2880 LOCal err_outl,err_mem
2890 :
2900   string$(0)='Attention, error:'&CHR$(0)
2910   IF error%
2920     string$(1)=ERRSTR$(error%)&CHR$(0)       : REMark make error string
2930   ELSE
2940     string$(1)=error_string$&CHR$(0)
2950   END IF
2960   pop_mem= 0
2970 :
2980  err_outl=PWcreate(0,PW('TYPE_OUTLINE'),PW('OUTLINE_TITLE_TEXT'),string$,PW('OUTLINE_QUIT'),PW('OUTLINE_QUIT_KEYPRESS'),27 )
2990 :
3000   info1=PWcreate(err_outl,PW('TYPE_INFOSTRING'),PW('INFOSTRING_TEXT'),file_name$)
3010   info1=PWcreate(err_outl,PW('TYPE_INFOSTRING'),PW('INFOSTRING_TEXT'),string$(1))
3020 :
3030   REMark now the main 'loop'
3040 :
3050   REPeat lp%
3060     err_mem=PWactivate(err_outl,err_mem,dummy,dummy,dummy%)
3070     IF err_mem=0:EXIT lp%
3080   END REPeat lp%
3090   PWremove err_outl           : REMark get rid of this window
3100 END DEFine err_window
3110 :
3120 REMark -------------------
3130 :
3140 DEFine PROCedure set_windows
3150 LOCal not_compiled,upper%,xo%,yo%,xs%,ys%,ysize_0%
3160   not_compiled=IS_OPEN(#0)     : REMark window#0 open?
3170   IF not_compiled
3180     xs%=0:ys%=0:xo%=0:yo%=0
3190     PWscrsize#0,xs%,ys%,xo%,yo%
3200     upper%=28:ysize_0%=50
3210     PWoutln#0,xs%,ys%-upper%,xo%,upper%+yo%
3220     WINDOW#0,xs%,ysize_0%,xo%,ys%-ysize_0%
3230     WINDOW#1,xs% DIV 2,ys%-upper%-ysize_0%,xo%+(xs% DIV 2),yo%+upper%
3240     WINDOW#2,xs% DIV 2,ys%-upper%-ysize_0%,xo%,yo%+upper%
3250     BORDER#1,1,255:BORDER#2,1,255
3260     PAPER#1,2:PAPER#2,7
3270     INK#1,7:INK#2,2
3280     CLS#0:CLS#1:CLS#2
3290   END IF
3300 END DEFine set_windows
3310 :
